#!/bin/sh
if test x$1 = "x"; then
 echo "Please specify the build target: rodent, rodent-lite"
 exit 1
fi
package=$1
tag=Core-rc2
description="Advanced user filemanager for Linux and BSD systems"
license=" GNU General Public License version 3 "
package_copyright="Copyright (c) 2000-2012 Edscott Wilson Garcia. <edscott@xfce.org>"

in_file=configure.ac.in
# Executables
  diff_e=no
  fgr_e=no
  fgrd_e=no
  mime_e=no
  root_e=no
  rodent_e=no
  desk_e=no
# Pseudo executables
  lite_pe=no
  getpass_pe=no
# Libraries
  tubo_l=no
  dbh_l=no
  icontheme_l=no
  desk_l=no
  grid_l=no
  mime_l=no
  primary_l=no
  rodent_l=no
# Modules
  combobox_m=no
  completion_m=no
  fgr_m=no
  icon_m=no
  mime_m=no
  mimezip_m=no
  ops_m=no
  properties_m=no
  run_m=no
  settings_m=no
# Plugins
  dotdesktop_p=no
  fuse_p=no
  fstab_p=no
  samba_p=no
  ps_p=no
# Dependencies
  filemagic=no
  libxml=no

case $package in
 rodent)
# Executables
  diff_e=yes
  fgr_e=yes
  fgrd_e=yes
  mime_e=yes
  root_e=yes
  rodent_e=yes
  desk_e=yes
# Pseudo executables
  lite_pe=yes
  getpass_pe=yes
# Libraries
  icontheme_l=yes
  tubo_l=yes
  dbh_l=yes
  desk_l=yes
  grid_l=yes
  mime_l=yes
  primary_l=yes
  rodent_l=yes
# Modules
  combobox_m=yes
  completion_m=yes
  fgr_m=yes
  icon_m=yes
  mime_m=yes
  mimezip_m=yes
  ops_m=yes
  properties_m=yes
  run_m=yes
  settings_m=yes
# Plugins
  dotdesktop_p=yes
  fuse_p=yes
  fstab_p=yes
  samba_p=yes
  ps_p=yes
# Dependencies
  filemagic=yes
  libxml=yes
 ;;
 rodent-lite)
  rodent_e=yes
  lite_pe=yes
  mime_l=yes
  primary_l=yes
  rodent_l=yes
  grid_l=yes
  tubo_l=yes
  dbh_l=yes
  fgrd_e=yes
  combobox_m=yes
  completion_m=yes
  fgr_m=yes
  ops_m=yes
  properties_m=yes
  run_m=yes
  settings_m=yes
  description="Advanced user filemanager (LITE) for Linux and BSD systems"
  mime_m=yes
  mimezip_m=yes
  libxml=yes
 ;;
esac
echo "Creating Rodent system specific build files for $package..."
# Executables:
cat $in_file | sed s/@FGR_E@/$fgr_e/ | sed s/@RODENT_E@/$rodent_e/ | sed s/@LITE_PE@/$lite_pe/ | sed s/@DESK_E@/$desk_e/ |  sed s/@GETPASS_PE@/$getpass_pe/ | sed s/@DIFF_E@/$diff_e/ | sed s/@MIME_E@/$mime_e/ | sed s/@ROOT_E@/$root_e/ > executables.in

cat rodent.settings.in | sed s/@FGR_E@/$fgr_e/ | sed s/@RODENT_E@/$rodent_e/ | sed s/@LITE_PE@/$lite_pe/ | sed s/@DESK_E@/$desk_e/ |  sed s/@GETPASS_PE@/$getpass_pe/ | sed s/@DIFF_E@/$diff_e/ | sed s/@MIME_E@/$mime_e/ | sed s/@ROOT_E@/$root_e/ > settings.1.in

# Libraries:
cat executables.in | sed s/@TUBO_L@/$tubo_l/ | sed s/@DBH_L@/$dbh_l/ | sed s/@ICONTHEME_L@/$icontheme_l/ | sed s/@DESK_L@/$desk_l/ | sed s/@GRID_L@/$grid_l/ | sed s/@MIME_L@/$mime_l/ | sed s/@PRIMARY_L@/$primary_l/ | sed s/@RODENT_L@/$rodent_l/ > libraries.in
rm executables.in

cat settings.1.in | sed s/@TUBO_L@/$tubo_l/ | sed s/@DBH_L@/$dbh_l/ | sed s/@ICONTHEME_L@/$icontheme_l/ | sed s/@DESK_L@/$desk_l/ | sed s/@GRID_L@/$grid_l/ | sed s/@MIME_L@/$mime_l/ | sed s/@PRIMARY_L@/$primary_l/ | sed s/@RODENT_L@/$rodent_l/ > settings.2.in
rm settings.1.in

# Modules:
cat libraries.in | sed s/@COMBOBOX_M@/$combobox_m/ | sed s/@COMPLETION_M@/$completion_m/ | sed s/@FGR_M@/$fgr_m/ | sed s/@ICON_M@/$icon_m/ | sed s/@MIME_M@/$mime_m/ | sed s/@MIMEZIP_M@/$mimezip_m/ | sed s/@OPS_M@/$ops_m/ | sed s/@PROPERTIES_M@/$properties_m/ | sed s/@RUN_M@/$run_m/ | sed s/@SETTINGS_M@/$settings_m/ > modules.in
rm libraries.in

cat settings.2.in | sed s/@COMBOBOX_M@/$combobox_m/ | sed s/@COMPLETION_M@/$completion_m/ | sed s/@FGR_M@/$fgr_m/ | sed s/@ICON_M@/$icon_m/ | sed s/@MIME_M@/$mime_m/ | sed s/@MIMEZIP_M@/$mimezip_m/ | sed s/@OPS_M@/$ops_m/ | sed s/@PROPERTIES_M@/$properties_m/ | sed s/@RUN_M@/$run_m/ | sed s/@SETTINGS_M@/$settings_m/ > settings.3.in
rm settings.2.in

# Plugins:
cat modules.in | sed s/@DOTDESKTOP_P@/$dotdesktop_p/ | sed s/@FUSE_P@/$fuse_p/ | sed s/@FSTAB_P@/$fstab_p/ | sed s/@SAMBA_P@/$samba_p/ | sed s/@PS_P@/$ps_p/ > plugins.in
rm modules.in

cat settings.3.in | sed s/@DOTDESKTOP_P@/$dotdesktop_p/ | sed s/@FUSE_P@/$fuse_p/ | sed s/@FSTAB_P@/$fstab_p/ | sed s/@SAMBA_P@/$samba_p/ | sed s/@PS_P@/$ps_p/ > settings.4.in
rm settings.3.in

# General:
cat plugins.in | sed s/@PACKAGE@/$package/ | sed s/@TAG@/$tag/  | sed s/@DESCRIPTION@/"$description"/ | sed s/@LICENSE@/"$license"/ | sed s/@PACKAGE_COPYRIGHT@/"$package_copyright"/ | sed s/@LIBXML@/$libxml/ | sed s/@FILEMAGIC@/$filemagic/ >  configure.ac
rm plugins.in

cat settings.4.in | sed s/@PACKAGE@/$package/ | sed s/@TAG@/$tag/  | sed s/@DESCRIPTION@/"$description"/ | sed s/@LICENSE@/"$license"/ | sed s/@PACKAGE_COPYRIGHT@/"$package_copyright"/ | sed s/@LIBXML@/$libxml/ | sed s/@FILEMAGIC@/$filemagic/ >  settings.in
rm settings.4.in

#| sed s/@@/$/  

if test -e Makefile ; then
 if test -e /usr/local/bin/gmake ; then
	gmake distclean
 else
    	make distclean
 fi
fi
#echo "** libtoolize -if ***"
 libtoolize -f >/dev/null; 
#echo "** aclocal -I m4 ***"
 aclocal -I m4 >/dev/null;
#echo "** autoheader ***"
 if test $package != "rodent-icon-theme"; then 
   autoheader >/dev/null;
 fi
#echo "** autoconf ***"
 autoconf >/dev/null;
#echo "** automake --add-missing ***"
 automake --add-missing >/dev/null;
 echo "You may now execute ./configure for $package"
 if (test x"$2" != "x"); then
   ./configure $2 $3 $4 $5 $6 $7 $8 $9
 fi

 exit 0
