#ifdef COPYRIGHT_INFORMATION
#include "gplv3.h"
#endif
////////////////////////////////////////////////////////////////////////////////////////
//             rodent_create_popup_bythread guts (threaded functions) 
//
//              everything in this file *must* be gdk mutex protected
//
//              No function in this file (or .c file) should use exported
//              function calls listed in .h file (to avoid deadlocks).
////////////////////////////////////////////////////////////////////////////////////////
#if 0

	{MENUITEM_TYPE,"file_menu_menu","subbookmark_item_yes","dynamic text","xffm/places_user-bookmarks/composite/stock_yes", \
	    ADD_BOOKMARK_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","subbookmark_item_no","dynamic text","xffm/places_user-bookmarks/composite/stock_no", \
	    REMOVE_BOOKMARK_CALLBACK},\

#endif

#define FILE_MENU_STUFF \
	{MENUITEM_TYPE,"file_menu_menu","newfile_menuitem", NEW_FILE_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","newdirectory_menuitem", NEWDIR_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","differences2", DIFFERENCES_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","rename_menuitem", RENAME_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","duplicate_menuitem", DUPLICATE_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","symlink_menuitem", SYMLINK_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","touch_menuitem", TOUCH_CALLBACK},\
	{MENUITEM_TYPE,"file_menu_menu","properties_menuitem", PROPERTIES_CALLBACK},\
	{NULL_TYPE} 


#define GO_STUFF \
	{MENUITEM_TYPE,"goto_menu_menu","goup_menuitem", GO_UP_CALLBACK},\
	{MENUITEM_TYPE,"goto_menu_menu","go_back_menuitem", GO_BACK_CALLBACK},\
	{MENUITEM_TYPE,"goto_menu_menu","go_forward_menuitem", GO_FORWARD_CALLBACK},\
	{MENUITEM_TYPE,"goto_menu_menu","refresh3", RELOAD_CALLBACK}

#define GOTO_MENU_STUFF \
	{MENUITEM_TYPE,"goto_menu_menu","goto2", JUMP_TO_CALLBACK},\
	GO_STUFF, \
	{NULL_TYPE} 

#define GOTO_MENU_STUFF2 \
    {SEPARATOR_TYPE,"goto_menu_menu","navigation_separator",{-1, NULL,NULL,}}, \
	{MENUITEM_TYPE,"goto_menu_menu","host2", GOTO_HOST_CALLBACK},\
	{MENUITEM_TYPE,"goto_menu_menu","home2", GOTO_HOME_CALLBACK},\
	{NULL_TYPE} 


#define SELECT_MENU_STUFF \
	{MENUITEM_TYPE,"select_menu_menu","select_all_menuitem", SELECT_ALL_CALLBACK},\
	{MENUITEM_TYPE,"select_menu_menu","select_invert_menuitem", SELECT_INVERT_CALLBACK},\
	{MENUITEM_TYPE,"select_menu_menu","select_byfilter_menuitem", SELECT_BYFILTER_CALLBACK},\
	{MENUITEM_TYPE,"select_menu_menu","unselect_byfilter_menuitem", UNSELECT_BYFILTER_CALLBACK},\
	{MENUITEM_TYPE,"select_menu_menu","unselect_all_menuitem", UNSELECT_ALL_CALLBACK},\
	{NULL_TYPE} 

#define SORT_MENU_STUFF \
	{CHECKITEM_TYPE,"sort_menu_menu","casesort_menuitem", CASE_SORT_CALLBACK},\
        {MENUITEM_TYPE,"sort_menu_menu","ascending1", SORT_ASCENDING_CALLBACK},\
	{MENUITEM_TYPE,"sort_menu_menu","descending1", SORT_DESCENDING_CALLBACK},\
    {SEPARATOR_TYPE,"sort_menu_menu","sort_separator",{-1, N_("Sort options"),NULL,}}, \
	{RADIOITEM_TYPE,"sort_menu_menu","unsorted6", TYPE_SORT_CALLBACK},\
	{RADIOITEM_TYPE,"sort_menu_menu","namesort", NAME_SORT_CALLBACK},\
	{RADIOITEM_TYPE,"sort_menu_menu","size6", SIZE_SORT_CALLBACK},\
	{RADIOITEM_TYPE,"sort_menu_menu","date6", DATE_SORT_CALLBACK},\
	{RADIOITEM_TYPE,"sort_menu_menu","owner6", OWNER_SORT_CALLBACK},\
	{RADIOITEM_TYPE,"sort_menu_menu","group6", GROUP_SORT_CALLBACK},\
	{RADIOITEM_TYPE,"sort_menu_menu","mode6", MODE_SORT_CALLBACK},\
	{NULL_TYPE} 
#if 0
#endif

#define VIEW_MENU_STUFF \
	{MENUITEM_TYPE,"view_menu_menu","newtab", NEW_TAB_CALLBACK},\
	{MENUITEM_TYPE,"view_menu_menu","newwindow", NEW_WINDOW_CALLBACK},\
	{CHECKITEM_TYPE,"view_menu_menu","show_hidden_menuitem", SHOW_HIDDEN_CALLBACK},\
	{CHECKITEM_TYPE,"view_menu_menu","preview_images_menuitem", PREVIEW_IMAGES_CALLBACK},\
    {SEPARATOR_TYPE,"view_menu_menu","iconsize_separator2", NULL_CALLBACK}, \
    {SEPARATOR_TYPE,"view_menu_menu","iconsize_separator",{-1, N_("Icon size:"),}}, \
	{RADIOITEM_TYPE,"view_menu_menu","compact_iconsize", COMPACT_ICONSIZE_CALLBACK},\
	{RADIOITEM_TYPE,"view_menu_menu","tiny_iconsize", TINY_ICONSIZE_CALLBACK},\
	{RADIOITEM_TYPE,"view_menu_menu","normal_iconsize", NORMAL_ICONSIZE_CALLBACK},\
	{RADIOITEM_TYPE,"view_menu_menu","big_iconsize", BIG_ICONSIZE_CALLBACK},\
	{RADIOITEM_TYPE,"view_menu_menu","huge_iconsize", HUGE_ICONSIZE_CALLBACK},\
    {SEPARATOR_TYPE,"view_menu_menu","iconsize_separator3",NULL_CALLBACK}, \
	{MENUITEM_TYPE,"view_menu_menu","default_iconsize", DEFAULT_ICONSIZE_CALLBACK},\
	{MENUITEM_TYPE,"view_menu_menu","default_iconsize_all", DEFAULT_ICONSIZE_ALL_CALLBACK},\
	{NULL_TYPE} 

#define HELP_MENU_STUFF \
	  {MENUITEM_TYPE,"help_menu_menu","keybindings_menuitem", KEYBINDINGS_CALLBACK},\
	  {MENUITEM_TYPE,"help_menu_menu","about2", ABOUT_CALLBACK},\
	  {MENUITEM_TYPE,"help_menu_menu","help_pdf", HELP_CALLBACK},\
	{NULL_TYPE} 



#define EDIT_STUFF \
	{MENUITEM_TYPE,"main_popup_menu","cut_menuitem", CUT_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","copy_menuitem", COPY_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","paste_menuitem", PASTE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","remove_menuitem", REMOVE_CALLBACK},\
	{SEPARATOR_TYPE,"main_popup_menu","edit_separator",{-1, NULL,NULL,}}, 

#define AUTOTYPE_STUFF \
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[0], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[1], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[2], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[3], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[4], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[5], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[6], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[7], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[8], AUTOTYPE_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu",auto_C_name[9], AUTOTYPE_CALLBACK},\
\
	{MENUITEM_TYPE,"main_popup_menu","autotype_Prun", AUTOTYPE_R_CALLBACK},

#define ACTION_STUFF \
	{MENUITEM_TYPE,"main_popup_menu", "open_with_menuitem", OPEN_WITH_CALLBACK},\
	{SEPARATOR_TYPE,"main_popup_menu","open_with_separator", NULL_CALLBACK },

#define EXEC_STUFF \
	{MENUITEM_TYPE,"main_popup_menu","terminal2", TERMINAL_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","run2", RUN_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","find2", SEARCH_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","addbookmark_menuitem", ADD_BOOKMARK_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","removebookmark_menuitem", REMOVE_BOOKMARK_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","mountP", MOUNT_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","unmountP", UNMOUNT_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","mount_broken", {-1, N_("There was a network error."),"xffm/emblem_no-access",}},


//	{SUBMENU_TYPE,"main_popup_menu","module1","Module1",NULL,}, 

#define MAIN_MENU_SUBMENUS \
	{SUBMENU_TYPE,"main_popup_menu","goto_menu",{-1, N_("Go"),"xffm/stock_go-forward"}}, \
	{SEPARATOR_TYPE,"main_popup_menu","exec_separator", NULL_CALLBACK}, \
	AUTOTYPE_STUFF \
	ACTION_STUFF \
	EXEC_STUFF \
	{SEPARATOR_TYPE,"main_popup_menu","file_separator", NULL_CALLBACK}, \
	{SUBMENU_TYPE,"main_popup_menu","file_menu",{-1, N_("File"),"xffm/stock_file/composite3/stock_goto-bottom",}}, \
	{SUBMENU_TYPE,"main_popup_menu","applications_menu",{-1, N_("Applications"),"xffm/category_utilities/composite3/stock_goto-bottom", }}, \
	{SUBMENU_TYPE,"main_popup_menu","sort_menu",{-1, N_("Sort"),}}, \
	{SUBMENU_TYPE,"main_popup_menu","view_menu",{-1, N_("View"),"xffm/stock_zoom-in/composite3/stock_goto-bottom",}}, \
	{SUBMENU_TYPE,"main_popup_menu","select_menu",{-1, N_("Select"),"xffm/actions_select-items/composite3/stock_goto-bottom",}}, \
	{SUBMENU_TYPE,"main_popup_menu","help_menu",{-1, N_("Help"),"xffm/stock_help/composite3/stock_goto-bottom",}}, \
	EDIT_STUFF \
	{MENUITEM_TYPE,"main_popup_menu","settings2", SETTINGS_CALLBACK},\
	{MENUITEM_TYPE,"main_popup_menu","exit2", CLOSE_CALLBACK},\
	{SEPARATOR_TYPE,"main_popup_menu","main_menu_separator", NULL_CALLBACK}, \
	{NULL_TYPE} 
//	{NULL_TYPE} 
#if 0
#endif
static gchar *auto_C_name[] = {AUTO_C_NAME};

static GtkWidget *
thread_add_menu_separator (GtkWidget * parent, gchar *text);
static GtkWidget *
thread_add_submenu (GtkWidget * parent, const gchar * label, const gchar * name, const gchar * iconfile);
static GtkWidget *
thread_mk_pixmap_menu (GtkWidget * parent, const gchar * icon_id, int caso);
static void
thread_multimenu_make(GtkAccelGroup * accel_group, menu_definitions_t *in_p);

static gboolean
mutex_controller(void){
    while (!rfm_global_p->window) rfm_threadwait();
    if (!rfm_get_widget(MAIN_POPUP_MENU_ID)){
	g_mutex_lock(rfm_global_p->popup_mutex);
	g_cond_wait(rfm_global_p->popup_ready, rfm_global_p->popup_mutex);
	g_mutex_unlock(rfm_global_p->popup_mutex);
    }
    return TRUE;

}

static gboolean
popup_controller(void){
    if (!rfm_global_p || rfm_global_p->self == g_thread_self()){
	g_error("popup_controller: only to be called from non main thread\n");
    }
    return mutex_controller();
}
    

static gboolean 
menu_item_button_press (GtkWidget *widget, GdkEvent  *event, gpointer data) {
    NOOP(stderr, "***** popup menu item %s button press\n", (gchar *)data);
    return FALSE;
}

static
void unmap (GtkWidget *widget, gpointer data){
    NOOP(stderr,  "****  popup menu unmap signal-----\n");
    g_object_set_data(G_OBJECT(rfm_global_p->window), "popup_mapped", NULL);
    // Since this is main thread business, a read lock request
    // will have deadlock potential.
    //widgets_t *widgets_p = rfm_get_widget("widgets_p");
    //view_t *view_p = widgets_p->view_p;
    //rfm_rw_lock_reader_unlock (&(view_p->mutexes.monitor_lock));

    return ;
}

static
void map (GtkWidget *widget, gpointer data){
    NOOP(stderr,  "****  popup menu map signal+++++\n");
    g_object_set_data(G_OBJECT(rfm_global_p->window), "popup_mapped", GINT_TO_POINTER(1));
    // Since this is main thread business, a read lock request
    // will have deadlock potential.
    //widgets_t *widgets_p = rfm_get_widget("widgets_p");
    //view_t *view_p = widgets_p->view_p;
    //rfm_rw_lock_reader_lock (&(view_p->mutexes.monitor_lock));
    return ;
}

static void *
thread_add_menu_item_f (gpointer data) {
    void **arg = data;
    GtkWidget * parent = arg[0];
    gchar * label = arg[1];
    gchar * name = arg[2];
    gchar * icon_id = arg[3];
    gpointer callback = arg[4];
    gpointer callback_data = arg[5];
    GtkWidget *w = gtk_image_menu_item_new_with_mnemonic (label);
    gtk_image_menu_item_set_always_show_image ((GtkImageMenuItem *) w, TRUE);
    if(icon_id){
        thread_mk_pixmap_menu (w, icon_id, MENU_PIXMAP);
    }
    gtk_widget_show (w);
    gtk_container_add (GTK_CONTAINER (parent), w);
    if (name) rfm_set_widget (w, name);
    if(callback){
        g_signal_connect ((gpointer) w, "activate", G_CALLBACK (callback), callback_data);
    }
    g_free(label);
    g_free(icon_id);
    g_free(name);
    g_free(arg);
    return w;

}

static GtkWidget *
thread_add_menu_item (GtkWidget * parent,
                   const gchar * name,
                   const gchar * label,
                   const gchar * icon_id,
                   gpointer callback, 
		   gpointer callback_data) {
    void **arg = (void **)malloc(6*sizeof(void *));
    if (!arg) g_error("malloc: %s\n", strerror(errno));
    arg[0] = parent;
    arg[1] = g_strdup(label);
    arg[2] = g_strdup(name);
    arg[3] = g_strdup(icon_id);
    arg[4] = callback;
    arg[5] = callback_data;
    GtkWidget *w = rfm_context_function(thread_add_menu_item_f, arg);
    return w;
}


static void *
thread_mk_radio_button_f (gpointer data)
{
    void **arg = data;
    GtkWidget * parent = arg[0];
    GSList ** radiogroup = arg[1]; 
    gchar * label = arg[2];
    gchar * name = arg[3];
    gpointer callback = arg[4];
    gpointer callback_data = arg[5];
    GtkWidget *w = gtk_radio_menu_item_new_with_mnemonic (*radiogroup, label);
    *radiogroup = gtk_radio_menu_item_get_group (GTK_RADIO_MENU_ITEM (w));
    gtk_widget_show (w);
    gtk_container_add (GTK_CONTAINER (parent), w);
    if (callback) g_signal_connect (G_OBJECT(w) , "toggled", G_CALLBACK (callback), callback_data);
    if(name) rfm_set_widget (w, name);
    g_free(label);
    g_free(name);
    g_free(arg);
    return w;
}

static GtkWidget *
thread_mk_radio_button (GtkWidget * parent,  
	GSList ** radiogroup, 
	const gchar * name, 
	const gchar * label, 
	gpointer callback, 		   
	gpointer callback_data){
    void **arg = (void **)malloc(6*sizeof(void *));
    if (!arg) g_error("malloc: %s\n", strerror(errno));
    arg[0] = parent;
    arg[1] = radiogroup;
    arg[2] = g_strdup(label);
    arg[3] = g_strdup(name);
    arg[4] = callback;
    arg[5] = callback_data;
    GtkWidget *w = rfm_context_function(thread_mk_radio_button_f, arg);
    return w;
}



static void *thread_mk_check_item_f(gpointer data){
    // test borken?
    // is it actually a different thread managed by the main thread
    // (internal to glib)?
    // if (rfm_global_p->self != g_thread_self())
	//	g_error("thread_mk_check_item_f is a main thread function\n");
    void **arg = data;
    GtkWidget * parent = arg[0];
    gchar * label = arg[1];
    gchar * name = arg[2];
    gchar * icon_id = arg[3];
    gpointer callback = arg[4];
    gpointer callback_data = arg[5];

    GtkWidget *w = gtk_check_menu_item_new_with_mnemonic (label);
    gtk_container_add (GTK_CONTAINER (parent), w);
    if (callback) {
	g_signal_connect ((gpointer) w, "button-press-event", 
		G_CALLBACK (menu_item_button_press),(gpointer)(label));
	g_signal_connect ((gpointer) w, "toggled", 
		G_CALLBACK (callback), callback_data);
    }
    if(name) rfm_set_widget (w, name);
    g_free(label);
    g_free(name);
    g_free(icon_id);
    g_free(arg);
    return w;
}

static GtkWidget *thread_mk_check_item(GtkWidget * parent,
                   const gchar * name,
                   const gchar * label,
                   const gchar * icon_id,
                   gpointer callback, 
		   gpointer callback_data){
    void **arg = (void **)malloc(6*sizeof(void *));
    if (!arg) g_error("malloc: %s\n", strerror(errno));
    arg[0] = parent;
    arg[1] = g_strdup(label);
    arg[2] = g_strdup(name);
    arg[3] = g_strdup(icon_id);
    arg[4] = callback;
    arg[5] = callback_data;
    GtkWidget *w = rfm_context_function(thread_mk_check_item_f, arg);
    return w;

}


static void *
thread_add_menu_separator_f (gpointer data) {
    void **arg = data;
    GtkWidget * parent = arg[0];
    gchar * text = arg[1];
    GtkWidget *w;
    if (text) {
	w = gtk_image_menu_item_new_with_mnemonic (text);
    } else {
	w = gtk_menu_item_new ();
    }
    gtk_widget_show (w);
    gtk_container_add (GTK_CONTAINER (parent), w);
    gtk_widget_set_sensitive (w, FALSE);
    g_free(text);
    g_free(arg);
    return w;
}

static GtkWidget *
thread_add_menu_separator (GtkWidget * parent, gchar *text) {
    void **arg = (void **)malloc(2*sizeof(void *));
    if (!arg) g_error("malloc: %s\n", strerror(errno));
    arg[0] = parent;
    arg[1] = g_strdup(text);
    GtkWidget *w;
    if (rfm_global_p->self == g_thread_self()){
	w = thread_add_menu_separator_f(arg);
    } else {
        w = rfm_context_function(thread_add_menu_separator_f, arg);
    }
    return w;
}


static void *
thread_mk_pixmap_menu_f (gpointer data) {

    void **arg = data;
    GtkWidget * parent = arg[0];
    gchar * icon_id = arg[1];
    gint caso = GPOINTER_TO_INT(arg[2]);
    GdkPixbuf *pb = arg[3];

    GtkWidget *w = gtk_image_new_from_pixbuf (pb);
    gtk_widget_show (w);

    switch (caso) {
    case BIGGER_MENU_PIXMAP:
    case MENU_PIXMAP:
        NOOP ("gtk_image_menu_item_set_image now...\n");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (parent), w);
        break;
    case BIGGER_BUTTON_PIXMAP:
    case BUTTON_PIXMAP:
        gtk_container_add (GTK_CONTAINER (parent), w);
        break;
    case OTHER_PIXMAP:
        gtk_box_pack_start (GTK_BOX (parent), w, FALSE, TRUE, 0);
        gtk_misc_set_padding (GTK_MISC (w), 4, 0);
        break;
    }
    g_free(icon_id);
    g_free(arg);
    return w;
}

static GtkWidget *
thread_mk_pixmap_menu (GtkWidget * parent, const gchar * icon_id, int caso) {
    GdkPixbuf *pb = NULL;

    NOOP (" gui_mk_pixmap_menu, icon_id: %s\n", icon_id);
    switch (caso) {
    case MENU_PIXMAP:
        pb = rfm_get_pixbuf (icon_id, SIZE_BUTTON);
        break;
    case BUTTON_PIXMAP:
        pb = rfm_get_pixbuf (icon_id, SIZE_BUTTON);
        break;
    case BIGGER_MENU_PIXMAP:
    case BIGGER_BUTTON_PIXMAP:
        pb = rfm_get_pixbuf (icon_id, SIZE_DIALOG);
        break;
    case OTHER_PIXMAP:
        pb = rfm_get_pixbuf (icon_id, SIZE_BUTTON);
        break;
    }
    if(!pb) {
        pb = rfm_get_pixbuf ("xffm/emote_cool", 
		(caso==BIGGER_BUTTON_PIXMAP || caso==BIGGER_MENU_PIXMAP)?
		SIZE_DIALOG:
		SIZE_BUTTON);
        NOOP ("Unable to get pixbuf for %s (unable to get any pixbuf at all!)\n", icon_id);
        return NULL;
    }

    void **arg = (void **)malloc(4*sizeof(void *));
    if (!arg) g_error("malloc: %s\n", strerror(errno));
    arg[0] = parent;
    arg[1] = g_strdup(icon_id);
    arg[2] = GINT_TO_POINTER(caso);
    arg[3] = pb;
    GtkWidget *w;
    if (rfm_global_p->self == g_thread_self()){
	w = thread_mk_pixmap_menu_f(arg);
    } else {
	w = rfm_context_function(thread_mk_pixmap_menu_f, arg);
    }
    return w;
}

static void *
thread_add_submenu_f (gpointer data) 
{ 
    // This test is broken?
    // Thread self does not return correct thread id?
    /*if (rfm_global_p->self != g_thread_self())
	g_error("thread_add_submenu_f is a main thread function: self=0x%x/0x%x\n", 
		GPOINTER_TO_INT(rfm_global_p->self),
		GPOINTER_TO_INT(g_thread_self()));*/
    void **arg = data;
    GtkWidget * parent = arg[0];
    gchar * label = arg[1];
    gchar * name = arg[2];
    gchar * icon_id = arg[3];
    
    GdkPixbuf *pixbuf=NULL;
    if (icon_id) {
	pixbuf=rfm_get_pixbuf(icon_id, TINY_ICON_SIZE);
    }
    NOOP ("thread_mk_menu(): RSS request starts\n");
	
    GtkWidget *menu_menu = gtk_menu_new ();
    g_signal_connect (menu_menu, "unmap", G_CALLBACK (unmap), (void *)name);
    g_signal_connect (menu_menu, "map", G_CALLBACK (map), (void *)name);

    if(name) {
        gchar *g = g_strconcat (name, "_menu", NULL);
        rfm_set_widget (menu_menu, g);
	g_free(g);
	NOOP(stderr, "set widget: %s\n", g);
    }
    if (parent) {
	GtkWidget *w = gtk_image_menu_item_new_with_mnemonic (label);
	if(name) rfm_set_widget (w, name);
	gtk_image_menu_item_set_always_show_image ((GtkImageMenuItem *) w, TRUE);
	if (pixbuf) {
	    GtkWidget *image=gtk_image_new_from_pixbuf(pixbuf);
	    gtk_image_menu_item_set_image((GtkImageMenuItem *)w, image);
	}

	gtk_widget_show_all (w);
	// add label menuitem to parent
	gtk_container_add (GTK_CONTAINER (parent), w);
	// attach submenu to label menuitem
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (w), menu_menu);
    }
   
    GtkWidget *v;
    v = gtk_menu_item_new_with_mnemonic (label);
    gtk_widget_show (v);
    gtk_container_add (GTK_CONTAINER (menu_menu), v);
    gtk_widget_set_sensitive (v, FALSE);
    GtkWidget *label_widget = gtk_bin_get_child (GTK_BIN (v));
    g_object_set_data(G_OBJECT(menu_menu), "label", label_widget);
    g_free(label);
    g_free(name);
    g_free(icon_id);
    g_free(arg);
    return menu_menu;
}

static GtkWidget *
thread_add_submenu (GtkWidget * parent, const gchar * label, const gchar * name, const gchar * icon_id) 
{ 
    void **arg = (void **)malloc(4*sizeof(void *));
    if (!arg) g_error("malloc: %s\n", strerror(errno));
    arg[0] = parent;
    arg[1] = g_strdup(label);
    arg[2] = g_strdup(name);
    arg[3] = g_strdup(icon_id);
    GtkWidget *w;
    w = rfm_context_function(thread_add_submenu_f, arg);
    thread_add_menu_separator (w, NULL);
    return w;
}

static void
thread_multimenu_make(GtkAccelGroup * accel_group, menu_definitions_t *in_p){

    menu_definitions_t *p = in_p;
    for (;p && p->type != NULL_TYPE; p++){
	GtkWidget *parent = rfm_get_widget(p->parent_id);
	GtkWidget *w = NULL;
	switch (p->type) {
	    case SUBMENU_TYPE:
		w = thread_add_submenu ( parent, _(p->callback.string), p->id, p->callback.icon);
		break;
	    case MENUITEM_TYPE:
		if (p->callback.function == NULL) {
		    p->callback.function = rodent_menu_callback;
		    p->callback.data = GINT_TO_POINTER(p->callback.function_id);
		}
		w = thread_add_menu_item ( parent, p->id, _(p->callback.string),  p->callback.icon, 
			p->callback.function, p->callback.data);
		break;
	    case CHECKITEM_TYPE:
		if (p->callback.function == NULL) {
		    p->callback.function = rodent_menu_callback;
		    p->callback.data = GINT_TO_POINTER(p->callback.function_id);
		}
		w = thread_mk_check_item(parent, p->id, _(p->callback.string),  
			p->callback.icon, 
			p->callback.function, p->callback.data);
		break;
	    case RADIOITEM_TYPE:;
		if (p->callback.function == NULL) {
		    p->callback.function = rodent_menu_callback;
		    p->callback.data = GINT_TO_POINTER(p->callback.function_id);
		}
		gchar *list_name = g_strconcat(p->parent_id, "_list", NULL);
		GSList **radiogroup_p = rfm_get_widget(list_name);
		g_free(list_name);
		w = thread_mk_radio_button(parent, radiogroup_p, p->id, _(p->callback.string), p->callback.function, p->callback.data);
		break;
	    case SEPARATOR_TYPE:
		w = thread_add_menu_separator (parent, _(p->callback.string));
		if(p->id) rfm_set_widget (w, p->id);
		break;
	}
    }
    return ;
}



//
static GtkWidget *
thread_mk_popup_menu (void) 
{
    GtkAccelGroup *accel_group = NULL;
    GtkWidget *main_popup = thread_add_submenu (NULL,  "Rodent", MAIN_POPUP_ID,  NULL);  

    menu_definitions_t submenu_definitions_p[] = {MAIN_MENU_SUBMENUS};
    thread_multimenu_make(accel_group, submenu_definitions_p); 

    // Go to submenu.

    menu_definitions_t goto_definitions_p[] = {GOTO_MENU_STUFF};
    thread_multimenu_make(accel_group, goto_definitions_p); 

    // Bookmarks in to menu:
    gint level;
    GtkWidget *parent = rfm_get_widget("goto_menu_menu");
    // Bookmark holders
    for(level = 0; level < DEEPEST_BOOK_MENU_LEVELS; level++) {
        gchar *name = g_strdup_printf ("%s-%d", "bookmark", level);
	thread_add_menu_item ( parent, name, name, "xffm/emblem_link", rodent_menu_callback, GINT_TO_POINTER(LEVEL_GOTO_ACTIVATE));
	g_free(name);
    }



    menu_definitions_t goto_definitions2_p[] = {GOTO_MENU_STUFF2};
    thread_multimenu_make(accel_group, goto_definitions2_p); 

    // Plugins
    GSList *list;
    GSList *plugin_list = rfm_find_plugins ();
    gint module_number = 0;
    for(list = plugin_list; list && list->data; list = list->next) {
        if(!rfm_is_root_plugin ((gchar *) (list->data))) {
	    NOOP(stderr, "%s is not a root module\n", 
		    (gchar *) (list->data));
	    continue;
	}
        
        if(++module_number > DEEPEST_MODULE_MENU_LEVELS)
            break;
        gchar *name = g_strdup ((gchar *) (list->data));
        const gchar *icon = rfm_get_plugin_icon (name);
        if(!icon){
	    icon = "xffm/stock_go-forward";
	}

        const gchar *label = rfm_get_plugin_label(name);
        if(!label){
            label = name;
	}
	GtkWidget *w =
	    thread_add_menu_item ( parent, name, label, icon, rodent_menu_callback, GINT_TO_POINTER(PLUGIN_GOTO_ACTIVATE));
	g_object_set_data(G_OBJECT(w),"module_name",g_strdup(name));
    }
 
    thread_add_menu_separator (parent, NULL);
    for(level = 0; level < DEEPEST_DIR_MENU_LEVELS; level++) {
        gchar *name = g_strdup_printf ("level-%d", level);
	thread_add_menu_item ( parent, name, name, "xffm/stock_goto-last", rodent_menu_callback, GINT_TO_POINTER(LEVEL_GOTO_ACTIVATE));
	g_free(name);
    }


    // file menu
    menu_definitions_t file_definitions_p[] = {FILE_MENU_STUFF};
    thread_multimenu_make(accel_group, file_definitions_p); 

    // select menu
    menu_definitions_t select_definitions_p[] = {SELECT_MENU_STUFF};
    thread_multimenu_make(accel_group, select_definitions_p); 

    // sort menu (view menu 1)
    menu_definitions_t sort_definitions_p[] = {SORT_MENU_STUFF};
    {
	gchar *list_name = g_strconcat(sort_definitions_p->parent_id, "_list", NULL);
	GSList *radiogroup = NULL;
	rfm_set_widget(&radiogroup, list_name);
	g_free(list_name);
    }
    thread_multimenu_make(accel_group, sort_definitions_p); 

    // iconsize menu (view menu 2)
		
    menu_definitions_t zoom_definitions_p[] = {VIEW_MENU_STUFF};
    {
	gchar *list_name = g_strconcat(zoom_definitions_p->parent_id, "_list", NULL);
	GSList *radiogroup = NULL;
	rfm_set_widget(&radiogroup, list_name);
	g_free(list_name);
    }
    thread_multimenu_make(accel_group, zoom_definitions_p); 

    // help menu
    menu_definitions_t help_definitions_p[] = {HELP_MENU_STUFF};
    thread_multimenu_make(accel_group, help_definitions_p); 
    return main_popup;
}

